
/**
 * Author:      Frdric Viela
 * Date:        2004
 *
 * Menu Aide:	Sebastian Gfeller, Andreas Jaggi
 */


import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

/**
* Fentre permettant de rgler les paramtres de connexion
*/

public class BConfigClient extends JFrame implements ActionListener {

    BClient bclient;

    JMenuBar jmb =                  new JMenuBar();
    JMenu config =                  new JMenu("Commandes");
    JMenuItem quitter =             new JMenuItem("Quitter");
    JMenuItem connecter =           new JMenuItem("Se connecter au serveur");
    JMenuItem lancer =              new JMenuItem("Lancer la partie");

    JMenu aide =                    new JMenu("Aide");
    JMenuItem indexAide =           new JMenuItem("Aide bomberman"); // la vraie "aide"
    JMenuItem apropos =             new JMenuItem("A propos");
    JMenuItem aufait =              new JMenuItem("Au fait");

    JInternalFrame jif1 =           new JInternalFrame("Paramtres connexion");
    JInternalFrame jif2 =           new JInternalFrame("Informations connexion");    

    JPanel jp1 =                    new JPanel();
    JPanel jp2 =                    new JPanel();
    JPanel jp3 =                    new JPanel();
    JPanel jp4 =                    new JPanel();
    JPanel jp5 =                    new JPanel();

    JTextArea info =                new JTextArea();
    JScrollPane areaScrollPane =    new JScrollPane(info);
    
    JTextField port =               new JTextField ("10000", 15);    
    JTextField nom =                new JTextField ("Bombmaster", 15);
    JTextField serveur =            new JTextField ("localhost", 15);
    ButtonGroup bg =                new ButtonGroup();
    JRadioButton humain =           new JRadioButton("Humain", true);
    JRadioButton ordinateur =       new JRadioButton("Ordinateur");
    
    int prt = 0;    
    String serv, nomJoueur;
    
    // Instance pour l'aide dans le programme
    private AideManager aideM = new AideManager();
    



    /** Constructor with the ability to config the client through command line arguments **/
    BConfigClient(BClient bclient1, String typ, String server, String port, String nom) {
	this(bclient1);
	
	if (typ.equals("humain"))
	    this.humain.setSelected(true);
	else
	    this.ordinateur.setSelected(true);
	this.serveur.setText(server);
	this.port.setText(port);
	this.nom.setText(nom);
	
    }

    /** Class Constructor
    * Ajoute au JFrame pour le client les elements necessaires.
    */

    BConfigClient(BClient bcl)  {
        super("Client - Bomberman Java 2004");
        
    		// shortcut key
        int mod = Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();
    		
        bclient = bcl;

        this.getContentPane().setLayout(new GridLayout(2, 1));        
        jif1.getContentPane().setLayout(new GridLayout(4, 1));    

	// Ajoute des raccourcis clavier et Tooltips au menu
        config.setMnemonic(KeyEvent.VK_C);
        config.add(connecter);
        connecter.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,mod));
	connecter.setToolTipText("Connecte avec le serveur utilisant ces donns");
        config.add(lancer);
        lancer.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L,mod));
	lancer.setToolTipText("Lance le jeu dans une nouvelle fentre");

        config.add(quitter);
        quitter.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,mod));
	config.setToolTipText("Quitte ce client");
        
	// Le menu aide
        aide.setMnemonic(KeyEvent.VK_A);

        indexAide.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_I,mod));
	indexAide.setToolTipText("Affiche le guide de l'utilisateur");
        aide.add(indexAide);

        apropos.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,mod));
	apropos.setToolTipText("Apropos Bomberman: Sur les auteurs");
        aide.add(apropos);

        aufait.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_U,mod));
	aufait.setToolTipText("Donne-moi une note");
        aide.add(aufait);

        this.activerLance(false);

        // action listeners pour le menu
        // appelle soi-mme, mthode actionPerformed fait la distinction des cas
        connecter.addActionListener(this);
        lancer.addActionListener(this);
        quitter.addActionListener(this);
        apropos.addActionListener(this);
        aufait.addActionListener(this);
        indexAide.addActionListener(this);

        jmb.add(config);
        
        // On a une version plus sophistique pour ajouter
        // le menu aide: setHelpMenu
	// Malheureusement ca ne fonctionne pas sur Linux:
	// pour compatibilit, j'utilisa la dernire methode
	jmb.add(aide);

        this.setSize(500, 360);
        this.setJMenuBar(jmb);
        centrer();
        this.setVisible(true);
        this.setResizable(false);

        jif1.setSize(150, 150);
        
        jp1.setLayout(new BorderLayout());
        jp2.setLayout(new BorderLayout());
        jp3.setLayout(new BorderLayout());
        jp4.setLayout(new BorderLayout());
        jp5.setLayout(new BorderLayout());
        
	// On ajoute des options de jeu: Nom, serveur de destination, port
        jp1.add(new Label("Nom du bomberman : "), BorderLayout.WEST);
	nom.setToolTipText("Votre sobriquet");
        jp1.add(nom, BorderLayout.EAST);

        jp2.add(new Label("Serveur :          "), BorderLayout.WEST);
	serveur.setToolTipText("Adresse de la machine o on joue");
        jp2.add(serveur, BorderLayout.EAST);

        jp3.add(new Label("Port :             "), BorderLayout.WEST);
	port.setToolTipText("Numro unique pour la connection de ce jeu");
        jp3.add(port, BorderLayout.EAST);
        
        bg.add(humain);
        bg.add(ordinateur);
        jp5.add(humain, BorderLayout.WEST);
        jp5.add(ordinateur, BorderLayout.EAST);
        jp4.add(new Label("Type de joueur :   "), BorderLayout.WEST);
        jp4.add(jp5, BorderLayout.EAST);
            
        jif1.setVisible(true);
        
        jif1.getContentPane().add(jp1);    
        jif1.getContentPane().add(jp2);
        jif1.getContentPane().add(jp3);
        jif1.getContentPane().add(jp4);
        jif1.getContentPane().doLayout();
        
        info.setEditable(false);
        info.setFont(new Font("newf", Font.ITALIC, 11));
        areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);            

        jif2.getContentPane().add(areaScrollPane);

        this.getContentPane().add(jif2);
        jif2.setVisible(true);
            
        this.getContentPane().add(jif1);

        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {                
                bclient.annuler();
            }
        });
    }

    /**
    * Gre les clics sur les boutons
    */

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == connecter) {
            nomJoueur = new String(nom.getText());
            serv = new String(serveur.getText());
            
            try {
                prt = Integer.decode(port.getText()).intValue();
            }
            catch(Exception ex) {
                System.out.println(ex);
            }

            info.append(nomJoueur + " : Tentative de connexion  " + serv + " sur le port " + prt + "...\n");

            bclient.lance();
        }

        if (e.getSource() == lancer) {
            try {
                // Avertit le serveur que la partie commence
                bclient.out.writeUTF("go");
                bclient.lancerJeu();
            }
            catch(Exception ex) {System.out.println(ex);}
        }

        if (e.getSource() == quitter) {
            this.removeNotify();
            bclient.annuler();
        }

        if ( e.getSource() == apropos ) {
            About aproposfenetre = new About(About.WINDOW_APROPOS);
            aproposfenetre.setVisible(true);
        }

        if ( e.getSource() == aufait ) {
            About aufaitfenetre = new About(About.WINDOW_AUFAIT);
            aufaitfenetre.setVisible(true);
        }

       if ( e.getSource() == indexAide ) {
           aideM.afficherAide();
       }
    }

    /**
    * Ajoute un message a la TextArea
    */

    void ecrire (String message) {
        Point p;

        info.append(message);

        // Dlai systeme pour rafraichissement
        try {
            Thread.sleep(50);
        }
        catch(Exception ex) {
            System.out.println(ex);
        }

        p = new Point(0, (int)(info.getSize().getHeight() - areaScrollPane.getViewport().getExtentSize().getHeight()));
        areaScrollPane.getViewport().setViewPosition(p);
    }

    /**
    * Active ou desactive l'entre menu pour la connexion
    */

    void activerConnecte(boolean b) {
        connecter.setEnabled(b);
    }

    /**
    * Active ou desactive l'entre menu pour le lancement de la partie
    */

    void activerLance(boolean b) {
        lancer.setEnabled(b);
    }

    /**
    * Donne le port de connexion au serveur
    */

    int port() {
        return prt;
    }

    /**
    * Donne le nom du serveur
    */

    String serveur() {
        return serv;
    }

    /**
    * Donne le nom du joueur
    */

    String nom() {
        return nomJoueur;
    }
    
    /**
    * Donne le type du client : 1 = humain, 2 = ordinateur
    */

    int typeClient() {
        int t;
        if (humain.isSelected()) t = 1;
        else if (ordinateur.isSelected()) t = 2;
        else t = 0;
        return t;
    }

    /**
    * Centre la fentre dans l'cran
    */

    void centrer() {
        Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();
        int largeurEcran = tailleEcran.width;
        int hauteurEcran = tailleEcran.height;
        int largeur = getSize().width;
        int hauteur = getSize().height;
        int xPos = (largeurEcran - largeur) / 2;
        int yPos = (hauteurEcran - hauteur) / 2;
        setLocation(xPos, yPos);
    }
}
