
/**
 * Author:      Frdric Viela
 * Date:        2004
 */


import java.awt.* ;
import java.awt.image.* ;

/** Cre un filtre de couleur:
* Permet de n'utiliser qu'une seule image pour tous les joueurs, en
* appliquant un filtre de couleur sur chaque image pour avoir des persos
* de couleurs diffrentes
*/

public class ColorChangeImage extends RGBImageFilter {
    // Couleur qui sera remplace dans l'image
    private Color aRemplacer;
    
    // Nouvelle couleur de l'image
    private Color remplacement;

    /**
    * Class Constructor
    * @param nouv Nouvelle couleur de l'image
    * @param rempl Couleur qui sera remplace
    */

    ColorChangeImage(Color nouv, Color rempl)  {
        canFilterIndexColorModel = true;
        aRemplacer = nouv;
        remplacement = rempl;
    }

    /**
    * Cre un filtre RGB en fonction de la couleur
    * mthode surcharge de la classe RGBImageFilter
    */

    public int filterRGB(int x, int y, int rgb) {
        // Retourne l'entier correspondant  la couleur
        if (rgb == aRemplacer.getRGB())  {
            return remplacement.getRGB();
        }
        return rgb;
    }    
}
