/**
 * "intelligence artificielle", gre le bomberman ordinateur, 
 * cre un thread qui appelle toutes les 80ms la fonction agir()
 * qui gre le comportement du bomberman ordinateur
 *
 * @author      Andreas Jaggi, Sebastian Gfeller
 * @created     7. Mai 2004
 * @version     Intelligence.java,v 1.13 2004/06/08 21:47:51 ajaggi Exp
 * @copyright   Andreas Jaggi, Sebastian Gfeller 2004
 * @license     http://opensource.org/licenses/gpl-license.php GNU Public License
 */

public class Intelligence implements Runnable, Constantes {

	/**
	 * Gre le plateau de jeu au niveau personnages et bombes
	 */
	Plateau plateau;

	/**
	 * Gre le plateau de jeu au niveau type de sols
	 */
	Niveau niveau;

	/**
	 * Le personnage ennemi
	 */
	Perso ennemi;

	/**
	 * Le personnage gr
	 */
	Perso gentil;

	/**
	 * La stratgie qu'on utilise
	 */
	Strategie strategie;


	/**
	 * Constructeur de Intelligence
	 *
	 * @param table  Plateau du jeu
	 * @param moi    Personnage  grer
	 * @param lui    Personnage ennemi
	 * @param monde  Niveau du jeu
	 */
	public Intelligence( Plateau table, Perso moi, Perso lui, Niveau monde ) {
	
		plateau = table;
		gentil = moi;
		ennemi = lui;
		niveau = monde;

		/* on cre une stratgie pour utiliser */
		this.strategie = new Strategie( table, moi, lui, monde, this );

		System.gc();
	}


	/**
	 * Le thread principal de Intelligence
	 */
	public void run() {
		/* Change la position du personnage tant que la partie dure */
		while ( !plateau.partie.finPartie() ) {
			if ( gentil.vivant ) {
				agir();
			}

			try {
				Thread.sleep( 80 );
			} catch ( Exception e ) {
				;
			}
		}
	}


	/**
	 * Bouge la person vers une direction donne
	 * jusqu' ce que la methode stop() est appel
	 *
	 * @param s  direction
	 */
	void deplacement( String s ) {
		if ( s.equals( "haut" ) ) {
			gentil.propj.key = gentil.propj.up;
		}
		if ( s.equals( "bas" ) ) {
			gentil.propj.key = gentil.propj.down;
		}
		if ( s.equals( "gauche" ) ) {
			gentil.propj.key = gentil.propj.left;
		}
		if ( s.equals( "droite" ) ) {
			gentil.propj.key = gentil.propj.right;
		}
	}


	/**
	 * Pose une bombe
	 */
	void poseBombe() {
		if ( gentil.nbBombe > 0 ) {
			plateau.envoyer( "POSE", gentil.coord.x, gentil.coord.y );
			gentil.poseBombe( gentil.coord.x, gentil.coord.y );
		}
	}


	/**
	 * Arrte la person
	 */
	void stop() {
		gentil.propj.key = 0;
	}


	/**
	 *  Faire agir le joueur ordinateur 
	 */
	void agir() {

		/* on appelle la mthode agir de la stratgie */
		this.strategie.agir();
	}
}

