package bombmapper;

import java.io.IOException;


/**
 * @author Sebastian Gfeller
 * @created Jun 15, 2004
 * @version BombMapper.java,v 1.8 2004/06/23 20:37:19 sgfeller Exp
 * @copyright Sebastian Gfeller, Andreas Jaggi 2004
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */
public class BombMapper {
	private LevelReader lvl;
	private LevelView vLevel;
	
	/** Cre un objet BombMapper qui contient
	 * des connections  la carte (Fichier level)
	 * La classe tend JFrame et affiche le contenu
	 * de la carte
	 * 
	 * @param levelname La destination o se trouve une carte  ouvrir
	 */
	public BombMapper(String levelname) {
		super();
		try {
			lvl = new LevelReader(levelname);
		} catch (ClassNotFoundException e) {
			System.out.println("Fichier "+levelname
					+" mal forme.");
		} catch (IOException e) {
			System.out.println("Problme entre/sortie");
			e.printStackTrace();
		}
		
		vLevel = new LevelView(lvl);
	}
	
	/** Cre un objet BombMapper qui contient des connections  la carte
	 * qui existe  ce moment seulement dans la mmoire si on appelle
	 * le constructeur sans arguments
	 */
	public BombMapper() {
		super();
		lvl = new LevelReader();
		vLevel = new LevelView(lvl);
	}

	/** Pour tout argument entre, on cre un objet
	 * BombMapper qui ouvre un fentre pour afficher
	 * la carte.
	 * @param args destinations des fichiers carte
	 */
	public static void main(String[] args) {
		if(args.length == 0) {
			// Pas de nom de fichier specifi. On ouvre un fichier nouveau
			BombMapper bmSansNom = new BombMapper();
		} else {
			// on fait un tableau avec tous les cartes  ouvrir.
			BombMapper[] bm = new BombMapper[args.length];
			for(int i=0;i<args.length;i++) {
				bm[i] = new BombMapper(args[i]);
			}
		}
	}
}
