package bombmapper;

import java.io.BufferedOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

/**
 * @author Sebastian Gfeller, Andreas Jaggi
 * @created Jun 15, 2004
 * @version LevelWriter.java,v 1.6 2004/06/24 16:45:28 sgfeller Exp
 * @copyright Sebastian Gfeller, Andreas Jaggi 2004
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */
public class LevelWriter extends Level {

	
	 // les noms des fichiers image des blocs: dfauts

	
	/** Si on appelle LevelWriter sans paramtres autre que le nom
	 * d'un fichier, cela signifie qu'on cre un nouveau fichier vide.
	 */
	public LevelWriter(String levelname) throws FileNotFoundException,IOException{
		super(levelname);
		
		remplirCarteValeursDefauts();
		write();
	}
	
	/** On ecrit dans le fichier levelname premirement les noms des images (spcifis par nomsFichiersTerrain)
	 * et aprs la carte (en format int[][]).
	 * 
	 * @param levelname Le chemin du fichier qu'on crit
	 * @param nomsFichiersTerrain Les noms des fichiers images du terrain utilis dans cette carte
	 * @param carte La carte  ecrire
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	public LevelWriter(String levelname,  String[] nomsFichiersTerrain, Block[][] carte) throws FileNotFoundException,IOException {
		super(levelname);
		
		this.nomFichier = nomsFichiersTerrain;
		this.carte = carte;
		
		// avec la carte, on cre la table type qui est crit dans le fichier
		type = new int[carte.length][carte[0].length];
		for(int y=0;y<type.length;y++) {
			for(int x=0;x<type[0].length;x++) {
				type[y][x] = carte[y][x].getType();
			}
		}
		
		write();
	}

	/** Ecrit les informations de nomsFichiersImages, carte (tous deux dfinis dans la super-classe
	 * Level) dans un fichier binaire avec le nom levelname
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	public void write() throws FileNotFoundException,IOException {
		FileOutputStream levelOutputStream = new FileOutputStream(levelname);
		BufferedOutputStream bufferedLevelOutputStream = new BufferedOutputStream(levelOutputStream);
		ObjectOutputStream objectLevelOutputStream = new ObjectOutputStream(bufferedLevelOutputStream);
		
		objectLevelOutputStream.writeObject(nomFichier);
		objectLevelOutputStream.writeObject(type);
		
		objectLevelOutputStream.close();
		bufferedLevelOutputStream.close();
	}
}
